define(['require'],
    function(require) {
        /**
         * Controller for index generated by Appery.io
         * @module index
         */
        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.user = Apperyio.EntityAPI('User');
            $scope.sampleMarkers = Apperyio.EntityAPI('String');
            $scope.lastHourGetLocations = Apperyio.EntityAPI('String');
            $scope.timeReloadLocations = Apperyio.EntityAPI('Number');
            $scope.marcas = Apperyio.EntityAPI('String');
            $scope.regiones = Apperyio.EntityAPI('String');
            $scope.tipoOrden = Apperyio.EntityAPI('String');
            $scope.estadoGarantia = Apperyio.EntityAPI('String');
            $scope.diasSeleccionCalendarioRetro = Apperyio.EntityAPI('Number');
            $scope.allNamesAsoc = Apperyio.EntityAPI('objeto');
            $scope.allUsernamesAsoc = Apperyio.EntityAPI('objeto');
            $scope.fechaModel = Apperyio.EntityAPI('String');
            $scope.myModal = Apperyio.EntityAPI('String');
            $scope.horaUltimaActividad = Apperyio.EntityAPI('String');
            $scope.statusDetectaUltimaActividad = Apperyio.EntityAPI('Boolean');
            $scope.isRoot = Apperyio.EntityAPI('Boolean');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                $scope.lastHourGetLocations = "2019-02-24 12:45:56";
                $scope.timeReloadLocations = 1000 * 30 * 5;
                $scope.timeDelayPopup = 200; //Segundos default de espera hasta que se lanza la ventana popup
                $scope.diasSeleccionCalendarioRetro = 0;
                $scope.centerMapApp = {
                    latitude: -33.439569,
                    longitude: -70.655669
                };
                $scope.limitGPSPositionTopLeft = {
                    latitude: -32.963293,
                    longitude: -71.776427
                };
                $scope.limitGPSPositionBottomRight = {
                    latitude: -34.350460,
                    longitude: -69.836842
                };
                $scope.paisDefault = "CHILE";
                $scope.secEventBusyDetect = 60 * 15; //Tiempo en segundo de inactividad máxima
                var nVer = navigator.appVersion;
                var nAgt = navigator.userAgent;
                var browserName = navigator.appName;
                var fullVersion = '' + parseFloat(navigator.appVersion);
                var majorVersion = parseInt(navigator.appVersion, 10);
                $scope.minLengthUsername = 6;
                $scope.minLengthPassword = 6;
                $scope.getUserIP(function(ip) {
                    $scope.uniqueToken = ip + nVer + nAgt + browserName + fullVersion
                });
                /*$scope.sampleMarkers = [
                        {
                            id: "1",
                            latitude: -33.447487,
                            longitude: -70.673676,
                            hour: "2019-02-24 12:45:56",
                            options: {draggable:false, icon: 'files/images/autochico.png'},
                            idUser: 123,
                            fullName: "Juan Pérez",
                            status: "60%"
                            
                        },
                        {
                            id: "2",
                            latitude: -33.468505,
                            longitude: -70.641589,
                            hour: "2019-02-24 12:45:56",
                            options: {draggable:false, icon: 'files/images/autochico.png'},
                            idUser: 124,
                            fullName: "Jorge Soto",
                            status: "34%"
                        },
                        {
                            id: "2",
                            latitude: -33.457758,
                            longitude: -70.610248,
                            hour: "2019-02-24 12:45:56",
                            options: {draggable:false, icon: 'files/images/autochico.png'},
                            idUser: 125,
                            fullName: "Rodrigo González",
                            status: "100%"
                        },
                    ];*/
                $scope.marcas = [{
                    codigo: "SAMS",
                    nombre: "SAMSUNG"
                }];
                $scope.regiones = [{
                        codigo: 1,
                        nombre: "Región de Tarapacá"
                    },
                    {
                        codigo: 2,
                        nombre: "Región de Antofagasta"
                    },
                    {
                        codigo: 3,
                        nombre: "Región de Atacama"
                    },
                    {
                        codigo: 4,
                        nombre: "Región de Coquimbo"
                    },
                    {
                        codigo: 5,
                        nombre: "Región de Valparaíso"
                    },
                    {
                        codigo: 6,
                        nombre: "Región del Libertador General Bernardo OHiggins"
                    },
                    {
                        codigo: 7,
                        nombre: "Región del Maule"
                    },
                    {
                        codigo: 8,
                        nombre: "Región del Biobío"
                    },
                    {
                        codigo: 9,
                        nombre: "Región de La Araucanía"
                    },
                    {
                        codigo: 10,
                        nombre: "Región de Los Lagos"
                    },
                    {
                        codigo: 11,
                        nombre: "Región Aysén del General Carlos Ibáñez del Campo"
                    },
                    {
                        codigo: 12,
                        nombre: "Región de Magallanes y Antártica Chilena"
                    },
                    {
                        codigo: 13,
                        nombre: "Región Metropolitana"
                    },
                    {
                        codigo: 14,
                        nombre: "Región de Los Ríos"
                    },
                    {
                        codigo: 15,
                        nombre: "Región de Arica y Parinacota"
                    },
                    {
                        codigo: 16,
                        nombre: "Región de Ñuble"
                    }
                ];
                $scope.regionesDecode = {};
                for (var i in $scope.regiones) {
                    $scope.regionesDecode[$scope.regiones[i].codigo] = $scope.regiones[i].nombre
                }
                $scope.tipoOrden = [{
                        codigo: "IH",
                        nombre: "In Home"
                    },
                    {
                        codigo: "II",
                        nombre: "Instalación Inicial"
                    },
                    {
                        codigo: "RH",
                        nombre: "RH"
                    }
                ];
                $scope.estadoGarantia = [{
                        codigo: "1",
                        nombre: "Garantía (repuestos - mano de obra)"
                    },
                    {
                        codigo: "2",
                        nombre: "Mano de Obra"
                    },
                    {
                        codigo: "3",
                        nombre: "Repuestos"
                    },
                    {
                        codigo: "4",
                        nombre: "Fuera de Garantía"
                    }
                ];
                /*$scope.stateList = {
                    1 : {
                        estado: "Creada", 
                        codigo: 1, 
                        color: "secondary", 
                        colorRGB: "#292b2c", 
                        validar: false, 
                        style:"", 
                        estadoFinal: false, 
                        estadoInicial: true, 
                        estadoTrabajo: false, 
                        optionsLocation: {
                                draggable:false, 
                                icon: 'files/images/locationplomo.png'
                        }},
                    2 : {
                        estado: "Asignada", 
                        codigo: 2, 
                        color: "primary", 
                        colorRGB: "#0275d8", 
                        validar: true, 
                        style:"font-weight: bold", 
                        estadoFinal: false, 
                        estadoInicial: false, 
                        estadoTrabajo: false, 
                        optionsLocation: {
                                draggable:false, 
                                icon: 'files/images/locationazul.png'
                        }},
                    3 : {
                        estado: "En Trabajo", 
                        codigo: 3, 
                        color: "info", 
                        colorRGB: "#5bc0de", 
                        validar: true, 
                        style:"font-weight: bold", 
                        estadoFinal: false, 
                        estadoInicial: false, 
                        estadoTrabajo: true, 
                        optionsLocation: {
                                draggable:false, 
                                icon: 'files/images/locationcalipso.png'
                        }},
                    4 : {
                        estado: "Finalizada", 
                        codigo: 4, 
                        color: "success", 
                        colorRGB: "#5cb85c", 
                        validar: false, 
                        style:"", 
                        estadoFinal: true, 
                        estadoInicial: false, 
                        estadoTrabajo: false, 
                        optionsLocation: {
                                draggable:false, 
                                icon: 'files/images/locationverde.png'
                        }},
                    5 : {
                        estado: "No Finalizada", 
                        codigo: 5, 
                        color: "warning", 
                        colorRGB: "#f0ad4e", 
                        validar: false, 
                        style:"", 
                        estadoFinal: true, 
                        estadoInicial: false, 
                        estadoTrabajo: false, 
                        optionsLocation: {
                                draggable:false, 
                                icon: 'files/images/locationamarillo.png'
                        }},
                    6 : {
                        estado: "Pendiente", 
                        codigo: 6, 
                        color: "danger", 
                        colorRGB: "#d9534f", 
                        validar: false, 
                        style:"", 
                        estadoFinal: true, 
                        estadoInicial: false, 
                        estadoTrabajo: false, 
                        optionsLocation: {
                                draggable:false, 
                                icon: 'files/images/locationrojo.png'
                        }}
                };*/
                //$scope.estadosCargaPermitidos = ["ST010", "ST015", "ST025", "ST030", "ST035"];
                $scope.listaRepuestos = [{
                        codigo: "AA001",
                        nombre: "Repuesto AA001",
                        estado: true,
                        cantidad: 1
                    },
                    {
                        codigo: "AA002",
                        nombre: "Repuesto AA002",
                        estado: true,
                        cantidad: 1
                    },
                    {
                        codigo: "AA003",
                        nombre: "Repuesto AA003",
                        estado: true,
                        cantidad: 1
                    },
                    {
                        codigo: "AA004",
                        nombre: "Repuesto AA004",
                        estado: true,
                        cantidad: 1
                    },
                    {
                        codigo: "AA005",
                        nombre: "Repuesto AA005",
                        estado: true,
                        cantidad: 1
                    },
                ];
            };
            /**
             * @function goToInicio
             */
            $scope.goToInicio = function() {
                Apperyio.navigateTo("Inicio", {});
            };
            /**
             * @function goToMapa
             */
            $scope.goToMapa = function() {
                Apperyio.navigateTo("Mapa", {});
            };
            /**
             * @function goToUsuarios
             */
            $scope.goToUsuarios = function() {
                Apperyio.navigateTo("Usuarios", {});
            };
            /**
             * @function goToBuscarOrdenes
             */
            $scope.goToBuscarOrdenes = function() {
                Apperyio.navigateTo("BuscarOrdenes", {});
            };
            /**
             * @function goToCargarOrdenes
             */
            $scope.goToCargarOrdenes = function() {
                Apperyio.navigateTo("CargarOrdenes", {});
            };
            /**
             * @function goToDescargarOrdenes
             */
            $scope.goToDescargarOrdenes = function() {
                Apperyio.navigateTo("DescargarOrdenes", {});
            };
            /**
             * @function goToOpciones
             */
            $scope.goToOpciones = function() {
                Apperyio.navigateTo("Opciones", {});
            };
            /**
             * @function stopLoading
             */
            $scope.stopLoading = function() {
                try {
                    if ($scope.statusLoading) {
                        $scope.statusLoading = false;
                        $scope.myModal.dismiss('cancel');
                    }
                } catch (e) {
                }
            };
            /**
             * @function showLoading
             * @param msg
             */
            $scope.showLoading = function(msg) {
                $scope.statusLoading = true;
                msgShow = msg || "Cargando...";
                Apperyio.get('Modals').loadModal("Cargando").then(
                    function(modal) {
                        modal.scope.current_item = {
                            // Set input object for send to modal window
                            // Value: .itemFromModal
                        };
                        modal.scope.modalInstance = modal.open({
                            // Optional settings:
                            size: 'sm',
                            /* 'lg' | 'sm' */
                            backdrop: true,
                            /* true | false | 'static' */
                            keyboard: true,
                            /* true | false */
                            backdropClass: '',
                            /* backdropClass name */
                            windowClass: '',
                            /* additional CSS class(es) to be added to a modal window template */
                            windowTemplateUrl: '' /* a path to a template overriding modal's window template */
                        });
                        modal.scope.modalInstance.result.then(
                            function(current_item) {
                                // Custom implementation with modal response with current_item
                            },
                            function(error) {
                                console.log(error);
                            }
                        );
                        $scope.myModal = modal.scope.modalInstance;
                    });
                setTimeout(function() {
                    if ($scope.statusLoading) {
                        $scope.stopLoading();
                        //$scope.mAlert("La operación está tardando más de lo esperado");
                    }
                }, 10000);
            };
            /**
             * @function goToDiistribucionOrdenes
             */
            $scope.goToDiistribucionOrdenes = function() {
                Apperyio.navigateTo("DistribucionOrdenes", {});
            };
            /**
             * @function goToEstadoActualOrdenes
             */
            $scope.goToEstadoActualOrdenes = function() {
                Apperyio.navigateTo("EstadoActualOrdenes", {});
            };
            /**
             * @function addZero
             * @param num
             */
            $scope.addZero = function(num) {
                return num < 10 ? "0" + num : num;
            };
            /**
             * @function mAlert
             * @param mensaje
             */
            $scope.mAlert = function(mensaje) {
                alert(mensaje);
            };
            /**
             * @function mConfirm
             * @param mensaje
             */
            $scope.mConfirm = function(mensaje) {
                return confirm(mensaje);
            };
            /**
             * @function goToEmpresa
             */
            $scope.goToEmpresa = function() {
                Apperyio.navigateTo("FichaEmpresa", {});
            };
            /**
             * @function goToMiCuenta
             */
            $scope.goToMiCuenta = function() {
                Apperyio.navigateTo("MiCuenta", {});
            };
            /**
             * @function goToFichaUsuario
             * @param codigo
             * @param username
             */
            $scope.goToFichaUsuario = function(codigo, username) {
                Apperyio.get('userManager').operatorId = codigo;
                Apperyio.get('userManager').operatorUsername = username;
                Apperyio.navigateTo("FichaUsuario", {});
            };
            /**
             * @function salir
             * @param deleteSession
             */
            $scope.salir = function(deleteSession) {
                if (deleteSession) {
                    //Borramos la sesión
                    $scope.operatorDataB = JSON.parse(localStorage.getItem("operatorData"));
                    $scope.userDataB = JSON.parse(localStorage.getItem("userData"));
                    var requestData = {};
                    requestData = (function mapping3206($scope) {
                        var requestData = {};
                        requestData.params = {};
                        requestData.params.lastSessionToken = $scope.uniqueToken; //$scope.userDataB.token;
                        requestData.params._id = $scope.operatorDataB._id;
                        requestData.params.deleteSession = true;
                        return requestData;
                        /*CLICK TO EDIT MAPPING*/
                    })($scope);
                    // read more about using rest services: https://links.appery.io/ve-snippet-rest
                    Apperyio.get("checkActivityAccount_service")(requestData).then(
                        function(success) { // success callback
                            /*CLICK TO EDIT MAPPING*/
                            console.log("Sesión eliminada con éxito");
                        },
                        function(error) { // callback to handle request error
                            console.log("ERROR: No se puede eliminar la sesión.");
                        },
                        function(notify) { // notify callback, can fire few times
                        });
                }
                $scope.statusDetectaUltimaActividad = false;
                localStorage.clear();
                sessionStorage.clear();
                window.localStorage.clear();
                Apperyio.navigateTo("Home", {});
            };
            /**
             * @function getDateFormat
             * @param fechaDB
             * @param tipo
             */
            $scope.getDateFormat = function(fechaDB, tipo) {
                if (fechaDB && fechaDB !== undefined) {
                    dateRevArr = fechaDB.split(" ");
                    dateArr = dateRevArr[0].split("-");
                    timeArr = dateRevArr[1].split(":");
                    if (tipo == "F")
                        return dateArr[2] + "/" + dateArr[1] + "/" + dateArr[0];
                    else if (tipo == "F2")
                        return dateArr[0] + "/" + dateArr[1] + "/" + dateArr[2];
                    else if (tipo == "H")
                        return timeArr[0] + ":" + timeArr[1];
                    else
                        return dateArr[2] + "/" + dateArr[1] + "/" + dateArr[0] + ", " + timeArr[0] + ":" + timeArr[1];
                } else {
                    return "";
                }
            };
            /**
             * @function detectaActividad
             */
            $scope.detectaActividad = function() {
                //Detecto que hay actividad en el sistema
                //si no ha habido actividad en x segundos, pregunto al server
                if ($scope.statusDetectaUltimaActividad) {
                    const diffTime = Math.round(Math.abs($scope.horaUltimaActividad - (new Date())) / 1000);
                    $scope.horaUltimaActividad = new Date();
                    if (diffTime > $scope.secEventBusyDetect) {
                        $scope.operatorDataB = JSON.parse(localStorage.getItem("operatorData"));
                        $scope.userDataB = JSON.parse(localStorage.getItem("userData"));
                        var requestData = {};
                        requestData = (function mapping3206($scope) {
                            var requestData = {};
                            requestData.params = {};
                            requestData.params.lastSessionHour = $scope.dateJsToDb(new Date());
                            requestData.params.lastSessionToken = $scope.uniqueToken; //$scope.userDataB.token;
                            requestData.params.secEventBusyDetect = $scope.secEventBusyDetect;
                            requestData.params._id = $scope.operatorDataB._id;
                            return requestData;
                            /*|button_mapping|onbeforesend|55FBECF9-2517-B35C-F991-D653406175BF||3206|*/
                        })($scope);
                        // read more about using rest services: https://links.appery.io/ve-snippet-rest
                        Apperyio.get("checkActivityAccount_service")(requestData).then( /*|service_bookmark|bookmark|55FBECF9-2517-B35C-F991-D653406175BF||8434|*/
                            function(success) { // success callback
                                /*|button_mapping|onsuccess|55FBECF9-2517-B35C-F991-D653406175BF||5408|*/
                                console.log("Ultima actividad actualizada con éxito");
                            },
                            function(error) { // callback to handle request error
                                $scope.mAlert("La sesión ha sido iniciada en otro equipo");
                                console.log("No se puede actualizar la sesión. Se ha iniciado en otro equipo");
                                $scope.salir(false);
                            },
                            function(notify) { // notify callback, can fire few times
                            });
                    }
                } else {
                    $scope.horaUltimaActividad = 0;
                }
            };
            /**
             * @function dateJsToDb
             * @param fecha
             */
            $scope.dateJsToDb = function(fecha) {
                if (fecha)
                    dateT = fecha.toISOString();
                else
                    dateT = ($scope.newDateLocale()).toISOString();
                return dateT.replace("T", " ").replace("Z", "");
            };
            /**
             * @function setStatusDetectaUltimaActividad
             * @param status
             */
            $scope.setStatusDetectaUltimaActividad = function(status) {
                $scope.statusDetectaUltimaActividad = status;
            };
            /**
             * @function showIf
             * @param cond
             * @param valueTrue
             * @param valueFalse
             */
            $scope.showIf = function(cond, valueTrue, valueFalse) {
                return cond ? valueTrue : valueFalse;
            };
            /**
             * @function findValueFromKey
             * @param array
             * @param key
             */
            $scope.findValueFromKey = function(array, key) {
                if (!array || !key)
                    return null;
                for (var i in array) {
                    if (array[i].key == key) {
                        return array[i].value;
                    }
                }
                return null;
            };
            /**
             * @function showMenu
             * @param menu
             */
            $scope.showMenu = function(menu) {
                var arrAdmin = ["Usuarios", "Empresa", "Cargar"];
                if (arrAdmin.includes(menu)) {
                    return $scope.isRoot;
                } else {
                    return true;
                }
            };
            /**
             * @function loadScopeConfig
             * @param config
             */
            $scope.loadScopeConfig = function(config) {
                if (!config)
                    return;
                $scope.config = config;
                if (config.dataListWeb) {
                    for (var i in config.dataListWeb) {
                        var elem = config.dataListWeb[i].value;
                        eval("$scope." + config.dataListWeb[i].name + "=elem");
                    }
                }
            };
            /**
             * @function addSeconds
             * @param seconds
             * @param date
             */
            $scope.addSeconds = function(seconds, date) {
                var today = date || (new Date());
                today.setSeconds(today.getSeconds() + seconds);
                return today;
            };
            /**
             * @function getUserIP
             * @param onNewIP
             */
            $scope.getUserIP = function(onNewIP) {
                //  onNewIp - your listener function for new IPs
                //compatibility for firefox and chrome
                var myPeerConnection = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection;
                var pc = new myPeerConnection({
                        iceServers: []
                    }),
                    noop = function() {},
                    localIPs = {},
                    ipRegex = /([0-9]{1,3}(\.[0-9]{1,3}){3}|[a-f0-9]{1,4}(:[a-f0-9]{1,4}){7})/g,
                    key;

                function iterateIP(ip) {
                    if (!localIPs[ip]) onNewIP(ip);
                    localIPs[ip] = true;
                }
                //create a bogus data channel
                pc.createDataChannel("");
                // create offer and set local description
                pc.createOffer(function(sdp) {
                    sdp.sdp.split('\n').forEach(function(line) {
                        if (line.indexOf('candidate') < 0) return;
                        line.match(ipRegex).forEach(iterateIP);
                    });
                    pc.setLocalDescription(sdp, noop, noop);
                }, noop);
                //listen for candidate events
                pc.onicecandidate = function(ice) {
                    if (!ice || !ice.candidate || !ice.candidate.candidate || !ice.candidate.candidate.match(ipRegex)) return;
                    ice.candidate.candidate.match(ipRegex).forEach(iterateIP);
                };
            };
        }
        return ['$scope', 'Apperyio', controller];
    });